local ____lualib = require("lualib_bundle")
local Set = ____lualib.Set
local __TS__New = ____lualib.__TS__New
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local ____exports = {}
local ____isaac_2Dtypescript_2Ddefinitions = require("isaac-typescript-definitions")
local ModCallback = ____isaac_2Dtypescript_2Ddefinitions.ModCallback
local ____shouldFire = require("shouldFire")
local shouldFireKnife = ____shouldFire.shouldFireKnife
local ____CustomCallback = require("classes.private.CustomCallback")
local CustomCallback = ____CustomCallback.CustomCallback
local v = {room = {firedSet = __TS__New(Set)}}
____exports.PostKnifeInitLate = __TS__Class()
local PostKnifeInitLate = ____exports.PostKnifeInitLate
PostKnifeInitLate.name = "PostKnifeInitLate"
__TS__ClassExtends(PostKnifeInitLate, CustomCallback)
function PostKnifeInitLate.prototype.____constructor(self)
    CustomCallback.prototype.____constructor(self)
    self.v = v
    self.shouldFire = shouldFireKnife
    self.postKnifeUpdate = function(____, knife)
        local ptrHash = GetPtrHash(knife)
        if not v.room.firedSet:has(ptrHash) then
            v.room.firedSet:add(ptrHash)
            self:fire(knife)
        end
    end
    self.callbacksUsed = {{ModCallback.POST_KNIFE_UPDATE, self.postKnifeUpdate}}
end
return ____exports
